{ Nema2BMP - Converter ist Freeware 2001 von Stefan Mogk           }
{ Bitte weiterentwickeln, verbessern und mir die berarbeitete     }
{ Version zumailen an kontakt@virtualmogk.de                        }
{                                                                  }
{ Entwickelt am Eberhard-Karls Universittsklinikum Tbingen       }
{                                                                  }
{ Mein Dank gilt Eberhard Kurz fr viele ntzliche Verbesserungen  }
{                                                                  }
{ Dieses Programm besteht aus den Teilen nema2bmp.exe /            }
{ nema2bmp.src / nema2bmp.pas und kann nur ausgefhrt werden wenn  }
{ alle Programmteile vorhanden sind.                               }
{                                                                  }
{ Compiliert mit Hilfe von FreePascal Compiler 1.0.4               }


{ Programmversion siehe unten }





{$asmmode intel }                               // Intel Assembler-Syntax
{$R-}                                           {Bereichberschreitung nicht}
                                                {prfen}

program Nema2BMP;

uses crt, go32, dos;

const nema2bmp_version = 'Version 1.0';   {Nema2BMP Version}
      MouseIRQ         = $33;

type about        = record                      {Bildinformationen}
                      recognition : string;
                      imanr       : word;
                      studydate   : string;
                      seriesdate  : string;
                      acdate      : string;
                      imagedate   : string;
                      studytime   : string;
                      seriestime  : string;
                      actime      : string;
                      imagetime   : string;
                      modality    : string;
                      patname     : string;
                      patid       : string;
                      patbirth    : string;
                      patsex      : string;
                      patage      : string;
                      slicethick  : string;
                      tr          : string;
                      te          : string;
                      ti          : string;
                      position    : string;
                      sliceloc    : string;
                      picx        : word;
                      picy        : word;
                      pixelsize   : string;
                      bitsalloc   : byte;
                      bitsstored  : byte;
                      highbit     : byte;
                      pixelrep    : byte;
                      header      : longint;
                    end;
     TFileList    = array[1..100] of record     {Bilder auf HD}
                      name        : string;
                      pat         : string;
                      datum       : record
                                      yyyy : word;
                                      mm   : byte;
                                      dd   : byte;
                                    end;
                      nr         : word;
                      mark       : boolean;
                    end;
     MouseState   = record
                      Button,X,Y :integer;
                    end;


var center, width : word;                        {Fensterungswerte}
    imainfo       : about;
    showx,showy   : word;                        {Dargestellte Bildgrsse}
                                                 {da meist verkleinertes Bild}
    FileList      : TFileList;                   {Bilder auf HD}
    Anzahl        : byte;                        {Anzahl Imas auf HD}
    DirecList     : array[1..15] of string;      {Verzeichnisse auf HD}
    AnzahlD       : byte;                        {Anzahl Direcs auf HD}
    WhatToDo      : byte;                        {Welche Menfunktion ?}
    nn,mm         : byte;                        {Zhlervariablen}
    cc            : char;
    CurDir        : string;                      {Verzeichnis zu Beginn}
    ImaPuffer     : pointer;
    Bildpuffer    : array[0..320*200-1] of byte;
    Mausi         : MouseState;


Procedure SchwererAusnahmefehler(err : string);  {Ein Verneigung vor}
                                                 {Windows :-) }
begin
  chdir(curdir);                                 {Anfangsverzeichnis}
  textmode(co80);                                {Textmodus}
  textbackground(0);
  textcolor(7);
  clrscr;
  writeln(err);                                  {Fehler}
  writeln('Nema2BMP kann leider nicht weiter ausgefhrt werden...');
  writeln;
  writeln('Sorry.');
  writeln;
  writeln;
  halt(1);                                       {Und tschss...}
end;


Procedure CheckCompleteness(datcc:string);       {berprfe Dateien auf}
                                                 {Vollstndigkeit}
var fcc     : file;
    filattr : word;

begin
  assign(fcc,datcc);
  {$I-}
  reset(fcc);
  close(fcc);
  {$I+}
  if ioresult<>0 then                           {Datei nicht gefunden}
  begin
    {$I-}                                       {...vieleicht liegts am}
    GetFAttr(fcc,filattr);                      {Schreibschutz ?}
    SetFAttr(fcc,(filattr xor $01));            {--> Schreibschutz entfernen}
    reset(fcc,1);                               {und nochmal versuchen}
    close(fcc);
    {$I+}
    if IOResult<>0 then                         {geht wieder nicht ?}
      SchwererAusnahmefehler('Die Datei '+datcc+' ist nicht vorhanden !');
  end;
end;


Procedure WaitRetrace;assembler;                 {Warten, bis Kathodenstrahl}
                                                 {ganz unten angelangt ist}
asm
  mov dx,3dah
@wait1:
  in al,dx
  test al,08h
  jnz @wait1
@wait2:
  in al,dx
  test al,08h
  jz @wait2
end;



procedure Fenster(x1,y1,x2,y2:word);            {Textmodus-Fenster anzeigen}

var inta, intb : integer;

begin
  if (x1<>0) then                               {Fenster oder Hintergrund ?}
  begin                                         {Fenster}
    textbackground(1);
    textcolor(15);
    gotoxy(x1,y1);
    write(chr(201));
    for inta:=x1+1 to x2-1 do write(chr(205));
    write(chr(187));
    for inta:=y1+1 to y2-1 do
    begin
      gotoxy(x1,inta);
      write(chr(186));
      for intb:=x1+1 to x2-1 do write(chr(32));
      write(chr(186));
    end;
    gotoxy(x1,y2);
    write(chr(200));
    for inta:=x1+1 to x2-1 do write(chr(205));
    write(chr(188));
  end else
  begin                                         {Hintergrund}
    textmode(co80);
    textbackground(7);
    clrscr;
    textcolor(0);
    writeln('   Aktualisieren      Dateiinfo       Anzeigen/Konvertieren      Quit [Esc]');
    gotoxy(1,25);
    write('  Nema2bmp                                                                Info');
    gotoxy(12,25);
    write(nema2bmp_version);
    textcolor(4);
    gotoxy(04,1); write('A');
    gotoxy(23,1); write('D');
    gotoxy(48,1); write('K');
    gotoxy(66,1); write('Q');
    gotoxy(75,25); write('I');
    textcolor(1);
    for inta:=2 to 24 do for intb:=1 to 80 do
    begin
      gotoxy(intb,inta);
      write(chr(176));
    end;
  end;
end;


procedure Graph(init:boolean);                  {Grafikmodus ein/aus}

var pal         : array[0..255,1..3] of byte;
    regs        : trealregs;
    x           : byte;
    y           : word;
    dos_pal     : longint;
    src         : file;                         {src-datei -> Bildleiste}
    t           : longint;

begin
  if init then regs.al:=$13 else regs.al:=$03;  {320x200x256 oder Textmodus}
  regs.ah:=0;
  realintr($10,regs);
  if init then                                  {Farbpalette festlegen}
  begin
    dos_pal:=global_dos_alloc(256*3);           {REAL-Mode-Speicher allokieren}
    for x:=0 to 255 do
      begin
        pal[x,1]:=x * 63 div 255;               {Belegung mit 63 Graustufen}
        pal[x,2]:=pal[x,1];
        pal[x,3]:=pal[x,1];
      end;
                                    {Palette in den REAL-Mode-Speicher kopieren}
    dosmemput(seg(dos_pal),ofs(dos_pal),pal,256*3);
    regs.ah:=$10;
    regs.al:=$12;
    regs.bx:=0;
    regs.cx:=256;
    regs.es:=seg(dos_pal);
    regs.dx:=ofs(dos_pal);
    realintr($10,regs);                         {Farbpalette setzen}
    global_dos_free(dos_pal);                   {REAL-Mode-Speicher freigeben}
    t:=ofs(bildpuffer);
    asm                                         {Bildpuffer leeren}
      push es              // ES-Register sichern
      push ds              // DS-Register in ES-Register kopieren
      pop es
      mov edi, t           // Adresse des Bildpuffers in EDI kopieren
      mov ecx, (320*50)    // Anzahl zu kopierender DWORDS
      xor eax, eax         // Fllwert 0
      cld                  // Adresse erhhen
      rep stosd            // ECX oft Inhalt von EAX in Bildpuffer kopieren
      pop es               // ES-Register zurckholen
    end;
    assign(src,curdir+'\nema2bmp.src');         {Bildleiste einlesen}
    reset(src,90);
    for y:=0 to 199 do
      blockread(src,bildpuffer[y*320+230],1);
    close(src);
  end;
end;


procedure GetHeader(name : string);             {Header einlesen}

var open       : file;
    buf        : string;
    i,gr,el    : integer;
    c          : char;
    code       : integer;
    filattr    : word;

begin
  ImaInfo.recognition:='';                      {Alle Variablen zurcksetzen}
  ImaInfo.imanr:=0;
  ImaInfo.studydate:='';
  ImaInfo.seriesdate:='';
  ImaInfo.acdate:='';
  ImaInfo.imagedate:='';
  ImaInfo.studytime:='';
  ImaInfo.seriestime:='';
  ImaInfo.actime:='';
  ImaInfo.imagetime:='';
  ImaInfo.modality:='';
  ImaInfo.patname:='';
  ImaInfo.patid:='';
  ImaInfo.patbirth:='';
  ImaInfo.patsex:='';
  ImaInfo.patage:='';
  ImaInfo.slicethick:='';
  ImaInfo.tr:='';
  ImaInfo.te:='';
  ImaInfo.ti:='';
  ImaInfo.position:='';
  ImaInfo.sliceloc:='';
  ImaInfo.picx:=0;
  ImaInfo.picy:=0;
  ImaInfo.pixelsize:='';
  ImaInfo.bitsalloc:=0;
  ImaInfo.bitsstored:=0;
  ImaInfo.highbit:=0;
  ImaInfo.pixelrep:=0;
  ImaInfo.header:=0;
  assign(open,name);                            {Datei ffnen}
  {$I-}
  reset(open,1);
  {$I+}
  if IOResult<>0 then                           {Fehler beim ffnen !}
  begin
    {$I-}                                       {...vieleicht liegts am}
    GetFAttr(open,filattr);                     {Schreibschutz ?}
    SetFAttr(open,(filattr xor $01));           {--> Schreibschutz entfernen}
    reset(open,1);                              {und nochmal versuchen}
    {$I+}
    if IOResult<>0 then                         {geht wieder nicht ?}
      SchwererAusnahmefehler('Warnung :   Auf die Datei'
        +#10#13+name+#10#13+'ist kein Zugriff mglich !');
  end;
  imainfo.header:=0;                            {Entfernung bis Bilddaten}
  repeat
    {$I-}
    blockread(open,c,1);                        {Gruppen ID auslesen}
    gr:=ord(c);
    blockread(open,c,1);
    inc(gr,ord(c) shl 8);
    blockread(open,c,1);                        {Element ID auslesen}
    el:=ord(c);
    blockread(open,c,1);
    inc(el,ord(c) shl 8);
    if not ((gr=$7FE0) and (el=$0010)) then     {Aufpassen dass nicht}
    begin                                       {auslesen ganzes Bild}
      blockread(open,c,1);                      {Bytes zum nchst. Element ?}
      i:=ord(c);
      blockread(open,c,1);
      inc(i,ord(c) shl 8);
      blockread(open,c,1);
      inc(i,ord(c) shl 16);
      blockread(open,c,1);
      inc(i,ord(c) shl 24);
      buf:='                                                  ';
      if i<=50 then
        blockread(open,buf[1],i)                {Element-Daten auslesen}
      else
      begin
        blockread(open,buf[1],50);              {max 50 Zeichen merken}
        seek(open,filepos(open)+i-50);
      end;
      buf:=copy(buf,1,i);
      if not ((gr=$0008) and (el=$0018)) then
        buf:=copy(buf,1,30);
      inc(imainfo.header,8+i);                  {Entfernung bis Bilddaten}
      case gr of                                {Element-Daten zuordnen}
      $0008 : begin
              if el=$0010 then imainfo.recognition:=buf;
              if el=$0018 then val(copy(buf,length(buf)-2,3),imainfo.imanr,code);
              if el=$0020 then imainfo.studydate:=buf;
              if el=$0021 then imainfo.seriesdate:=buf;
              if el=$0022 then imainfo.acdate:=buf;
              if el=$0023 then imainfo.imagedate:=buf;
              if el=$0030 then imainfo.studytime:=buf;
              if el=$0031 then imainfo.seriestime:=buf;
              if el=$0032 then imainfo.actime:=buf;
              if el=$0033 then imainfo.imagetime:=buf;
              if el=$0060 then imainfo.modality:=buf;
              end;
      $0010 : begin
              if el=$0010 then imainfo.patname:=buf;
              if el=$0020 then imainfo.patid:=buf;
              if el=$0030 then imainfo.patbirth:=buf;
              if el=$0040 then imainfo.patage:=buf;
              if el=$1010 then imainfo.patage:=buf;
              end;
      $0018 : begin
              if el=$0050 then imainfo.slicethick:=buf;
              if el=$0080 then imainfo.tr:=buf;
              if el=$0081 then imainfo.te:=buf;
              if el=$0082 then imainfo.ti:=buf;
              end;
      $0020 : begin
              if el=$1040 then imainfo.position:=buf;
              if el=$1041 then imainfo.sliceloc:=buf;
              end;
      $0028 : begin
              if el=$0010 then imainfo.picy:=ord(buf[1]) + (ord(buf[2]) shl 8);
              if el=$0011 then imainfo.picx:=ord(buf[1]) + (ord(buf[2]) shl 8);
              if el=$0030 then imainfo.pixelsize:=buf;
              if el=$0100 then imainfo.bitsalloc:=ord(buf[1]);
              if el=$0101 then imainfo.bitsstored:=ord(buf[1]);
              if el=$0102 then imainfo.highbit:=ord(buf[1]);
              if el=$0103 then imainfo.pixelrep:=ord(buf[1]);
              end;
      end;
    end else inc(ImaInfo.header,8);
    {$I+}
  until ((gr=$7FE0) and (el=$0010))             {Bilddaten - Kennung}
        or (IOResult<>0);                       {oder Fehler}
  close(open);
  if not ((gr=$7FE0) and (el=$0010)) then
    SchwererAusnahmefehler('Warnung:  '+name+' ist keine gltige NEMA-Datei !');
end;


procedure ShowHeader(DatHeader : String);       {Dateiinformationen anzeigen}

begin
  fenster(2,5,78,21);
  gotoxy(4,7);  writeln('Dateiname :  ',DatHeader);
  gotoxy(4,8);  writeln('Identifizierung :');
  gotoxy(4,9);  writeln('   Erkennungscode            :  ',imainfo.recognition);
  gotoxy(4,10);  writeln('   Bild Nr.                  :  ',imainfo.imanr);
  gotoxy(4,11);  writeln('   Studie Datum / Zeit       :  ',copy(ImaInfo.StudyDate,9,2),'.',copy(ImaInfo.StudyDate,6,2),
                         '.',copy(ImaInfo.StudyDate,1,4),'  ',imainfo.studytime);
  gotoxy(4,12);  writeln('   Serie Datum / Zeit        :  ',copy(ImaInfo.SeriesDate,9,2),'.',copy(ImaInfo.SeriesDate,6,2),
                         '.',copy(ImaInfo.SeriesDate,1,4),'  ',imainfo.seriestime);
  gotoxy(4,13);  writeln('   Acquisition Datum / Zeit  :  ',copy(ImaInfo.AcDate,9,2),'.',copy(ImaInfo.AcDate,6,2),
                         '.',copy(ImaInfo.AcDate,1,4),'  ',imainfo.actime);
  gotoxy(4,14);  writeln('   Bild Datum / Zeit         :  ',copy(ImaInfo.ImageDate,9,2),'.',copy(ImaInfo.ImageDate,6,2),
                         '.',copy(ImaInfo.ImageDate,1,4),'  ',imainfo.imagetime);
  gotoxy(4,15);  writeln('   Modalitt                 :  ',imainfo.modality);
  gotoxy(4,16);  writeln('Patient :');
  gotoxy(4,17);  writeln('   Name                      :  ',imainfo.patname);
  gotoxy(4,18);  writeln('   ID                        :  ',imainfo.patid:10,   '         Geschlecht    :  ',imainfo.patsex);
  gotoxy(4,19);  writeln('   Geburtstag                :  ',copy(ImaInfo.PatBirth,9,2),'.',copy(ImaInfo.PatBirth,6,2),
                         '.',copy(ImaInfo.PatBirth,1,4),'         Alter         :  ',imainfo.patage);
  gotoxy(80,25);
  repeat until keypressed;
  while keypressed do readkey;
  fenster(2,4,78,22);
  gotoxy(4,6);  writeln('Acquisition :');
  gotoxy(4,7);  writeln('   Schichtdicke SD           :  ',imainfo.slicethick,' mm');
  gotoxy(4,8);  writeln('   Wiederholungszeit TR      :  ',imainfo.tr,' ms');
  gotoxy(4,9);  writeln('   Echozeit TE               :  ',imainfo.te,' ms');
  gotoxy(4,10);  writeln('   Inversionszeit TI         :  ',imainfo.ti,' ms');
  gotoxy(4,11);  writeln('   Position                  :  ',imainfo.position);
  gotoxy(4,12);  writeln('   Schichtlokalisation       :  ',imainfo.sliceloc,' mm');
  gotoxy(4,14);  writeln('Bilddaten :');
  gotoxy(4,15);  writeln('   Matrix                    :  ',imainfo.picx,' x ',imainfo.picy);
  gotoxy(4,16);  writeln('   Pixelgrsse               :  ',imainfo.pixelsize,' Z\S in mm');
  gotoxy(4,17);  writeln('   Gespeicherte bits/pixel   :  ',imainfo.bitsalloc,' bits');
  gotoxy(4,18);
  writeln('   Tatschliche Farbtiefe    :  ',imainfo.bitsstored:2,' bits   ( High bit :  ',imainfo.highbit,' )');
  gotoxy(4,19);  writeln('   Pixelreprsentation       :  ',imainfo.pixelrep);
  gotoxy(4,20);  writeln('   Dateikopf (bis Bilddaten) :  ',imainfo.header);
  gotoxy(80,25);
  repeat until keypressed;
  while keypressed do readkey;
end;


procedure GetFileList;                          {Bilder, Bilddaten und}
                                                {Verzeichnisse auslesen}
var DirInfo : SearchRec;
    x,y     : word;
    code    : integer;
    put     : array[1..100] of byte;

    procedure ReSort;                           {FileList nach dem Sortieren}
    var open  : Text;                           {neu ordnen und zwar so, wie}
        del   : File;                           {von put[neues bild]=altes}
        n     : word;                           {bild beschrieben}
    begin
      assign(open,'temp.$$$');                  {neue FileList auf HD}
      rewrite(open);                            {zwischenspeichern}
      for n:=1 to anzahl do
      begin
        writeln(open,FileList[put[n]].Name);
        writeln(open,FileList[put[n]].Pat);
        writeln(open,FileList[put[n]].Datum.yyyy);
        writeln(open,FileList[put[n]].Datum.mm);
        writeln(open,FileList[put[n]].Datum.dd);
        writeln(open,FileList[put[n]].Nr);
      end;
      close(open);
      reset(open);                              {und jetzt in der richtigen}
      for n:=1 to anzahl do                     {Reihenfolge wieder einlesen}
      begin
        readln(open,FileList[n].Name);
        readln(open,FileList[n].Pat);
        readln(open,FileList[n].Datum.yyyy);
        readln(open,FileList[n].Datum.mm);
        readln(open,FileList[n].Datum.dd);
        readln(open,FileList[n].Nr);
      end;
      close(open);
      assign(del,'temp.$$$');                   {Temporre FileList lschen}
      erase(del);
    end;

begin
  Anzahl:=0;                                    {Anzahl Bilder auf HD}
  FindFirst('*.nem', $3F, DirInfo);             {alles Bilder in FileList}
  while DosError = 0 do
  begin
    inc(anzahl);
    FileList[anzahl].Name:=DirInfo.Name;
    FindNext(DirInfo);
    if anzahl=100 then DosError:=1;             {maximal jedoch 100 Stck}
  end;
  for x:=1 to anzahl do                         {jetzt Patientenname, Datum}
  begin                                         {und Bildnr auslesen}
    GetHeader(FileList[x].Name);
    FileList[x].pat:=ImaInfo.Patname;
    val(copy(ImaInfo.ImageDate,1,4),FileList[x].Datum.yyyy,code);
    if code<>0 then FileList[x].Datum.yyyy:=0;
    val(copy(ImaInfo.ImageDate,6,2),FileList[x].Datum.mm,code);
    if code<>0 then FileList[x].Datum.mm:=0;
    val(copy(ImaInfo.ImageDate,9,2),FileList[x].Datum.dd,code);
    if code<>0 then FileList[x].Datum.dd:=0;
    FileList[x].nr:=ImaInfo.Imanr;
    FileList[x].Mark:=False;
  end;
  for x:=1 to 100 do put[x]:=0;
  for x:=1 to anzahl do                         {Sortieren nach Nr}
  begin
    code:=1;                                    {Wieviele sind kleiner ?}
    for y:=1 to anzahl do
      if FileList[y].Nr<FileList[x].Nr then
        inc(code);
    while put[code]<>0 do inc(code);
    put[code]:=x;                               {put[neue pos]:=alte pos}
  end;
  ReSort;                                       {FileList in neue Reihenfolge}
  for x:=1 to 100 do put[x]:=0;
  for x:=1 to anzahl do                         {Sortieren nach Datum}
  begin
    code:=1;                                    {Wieviele sind kleiner ?}
    for y:=1 to anzahl do
      if (FileList[y].Datum.yyyy*10000
         +FileList[y].Datum.mm*100
         +FileList[y].Datum.dd) <
         (FileList[x].Datum.yyyy*10000
         +FileList[x].Datum.mm*100
         +FileList[x].Datum.dd) then
        inc(code);
    while put[code]<>0 do inc(code);
    put[code]:=x;                               {neue positionen}
  end;
  ReSort;                                       {und FileList wieder ordnen}
  for x:=1 to 100 do put[x]:=0;
  for x:=1 to anzahl do                         {Sortieren nach Name}
  begin
    code:=1;                                    {Wieviele sind kleiner ?}
    for y:=1 to anzahl do
      if FileList[y].Pat<FileList[x].Pat then
        inc(code);
    while put[code]<>0 do inc(code);
    put[code]:=x;                               {neue Positionen}
  end;
  ReSort;                                       {und FileList wieder ordnen}
  AnzahlD:=0;                                   {Anzahl Verzeichnisse}
  FindFirst('*.*', $10, DirInfo);
  while DosError = 0 do
  begin
  if DirInfo.attr = $10 then                    {zeigt sonst auch Dateinamen an}
   begin
    inc(AnzahlD);
    DirecList[AnzahlD]:=copy(DirInfo.Name,1,50);
   end;
    FindNext(DirInfo);
    if AnzahlD=15 then DosError:=1;             {maximal 15 Verz. anzeigen}
  end;
end;


Procedure DeleteFile(DelFile : string);         {Ausgewhlte Datei lschen}

var FiletoDelete : file;
    c            : char;
    n            : word;

begin
  Fenster(3,11,77,14);                          {Sicherheitsabfrage}
  gotoxy(5,12);
  write('Soll diese Datei wirklich gelscht werden ?   [J / N]');
  gotoxy(5,13);
  write(copy(DelFile,1,65));
  gotoxy(80,25);                                {Cursor weg}
  c:=readkey;
  if upcase(c)='J' then
  begin                                         {Lschen}
    {$I-}
    assign(FileToDelete, DelFile);
    erase(FileToDelete);
    {$I+}
    if IOResult<>0 then                         {Hat nicht geklappt...}
    begin
      gotoxy(5,12);
      write('Warnung :   Fehler beim Lschen der Datei ....    Bitte warten  ');
      gotoxy(80,25);
      delay(2000);
    end;
  end;
  TextBackground(7);                            {Hintergrund wiederherstellen}
  TextColor(1);
  gotoxy(1,2);
  for n:=2 to 23*80 do write(chr(176));
end;


function Choose : byte;                         {Hauptmen - Auswahlfunktion}

var x, y, Pos,                                  {pos: Dateiwahlbalken auf}
    Scroll, Erg   :  byte;                      {     (pos). Stelle von oben}
    n             :  word;
    c             :  char;                      {scroll: Nr der obersten}
    kurzname      :  string;

begin
  Fenster(4,4,75,22);                           {Dateiwahlfenster}
  Pos:=1;                                       {Auswahl an Pos 1 beginnen}
  Scroll:=1;
  Erg:=0;                                       {Rckmeldung von Choose}
  repeat
    y:=4;
    if Scroll<=AnzahlD then
    for x:=Scroll to AnzahlD do
    begin
      inc(y);
      if Pos=(Scroll+y-5) then
      begin
        TextBackground(3);
        TextColor(14);
      end;
      gotoxy(6,y);
      write('    ',DirecList[x],
        copy('                                                                ',1
        ,64-length(DirecList[x])));
      if Pos=(Scroll+y-5) then
      begin
        TextBackground(1);
        TextColor(15);
      end;
     end;
    if Scroll>(AnzahlD+1) then n:=scroll-AnzahlD else n:=1;
    for x:=n to Anzahl do
    begin
      inc(y);
      if Pos=(Scroll+y-5) then
      begin
        TextBackground(3);
        TextColor(14);
      end;
      gotoxy(6,y);
      if FileList[x].mark then write(chr(175),'   ')
      else write('    ');
      if length(FileList[x].Name)>14 then
        kurzname:=copy(FileList[x].Name,1,14)+'...'
        else kurzname:=FileList[x].Name;
      write(copy(FileList[x].Pat,1,20), copy('                   ',
            1,20-length(FileList[x].Pat)), FileList[x].Datum.dd:2,
            '.',FileList[x].Datum.mm:2,'.',FileList[x].Datum.yyyy:4,
            '     ','Ima ',FileList[x].Nr:3, '     ',
            Kurzname,'':(17-Length(FileList[x].Name)));
      if Pos=(Scroll+y-5) then
      begin
        TextBackground(1);
        TextColor(15);
      end;
      if y=21 then x:=Anzahl;
    end;
    while y<21 do
    begin
      inc(y);
      gotoxy(6,y);
      write('                                                                     ');
    end;
    gotoxy(80,25);                              {Cursor weg}
    c:=readkey;                                 {auf Eingabe warten}
    if (c=' ') and (Pos>AnzahlD) then           {Dateien markieren}
    begin
      FileList[Pos-AnzahlD].Mark:=FileList[Pos-AnzahlD].Mark xor true;
      if (Pos<(Anzahl+AnzahlD)) then inc(Pos);  {eins runter}
      if (Pos>(Scroll+16)) and (Scroll<(Anzahl+AnzahlD)) then inc(Scroll);
    end;
    if (ord(c)=0) and keypressed then           {Eingabe normalen Tasten}
      c:=readkey else
      begin
        if (upcase(c)='A') then erg:=1;         {Dateiliste aktualisieren}
        if (upcase(c)='K') then erg:=2;         {Anzeigen / Konvertieren}
        if (upcase(c)='Q') or (ord(c)=27) then erg:=3;  {Programmende}
        if (ord(c)=13) and (Pos<=AnzahlD) then  {Verzeichnis wechseln}
        begin
          chdir(DirecList[Pos]);
          Erg:=1;                               {jetzt aktualisieren !}
        end;
        if (upcase(c)='D') and (pos>AnzahlD) then
        begin                                   {Dateiinfo anzeigen}
          TextBackground(7);
          TextColor(1);
          gotoxy(1,2);
          for n:=2 to 23*80 do write(chr(176));
          GetHeader(FileList[pos-AnzahlD].Name);
          ShowHeader(copy(FileList[pos-AnzahlD].Name,1,60));
          Textbackground(7);
          Textcolor(1);
          gotoxy(1,2);
          for n:=2 to 23*80 do write(chr(176));
          Fenster(4,4,75,22);
        end;
        if (upcase(c)='I') then                 {Programminfo anzeigen}
        begin
          TextBackground(7);
          TextColor(1);
          gotoxy(1,2);
          for n:=2 to 23*80 do write(chr(176));
          fenster(24,8,56,17);
          gotoxy(26, 9); write('    Nema2BMP - Converter     ');
          gotoxy(26,10); write('    ====================     ');
          gotoxy(26,12); write('Freeware 2001 von Stefan Mogk');
          gotoxy(26,13); write('    Stefan@virtualmogk.de    ');
          gotoxy(26,15); write(' Eberhard-Karls Universitt  ');
          gotoxy(26,16); write('      Klinikum Tbingen      ');
          gotoxy(80,25);
          readkey;
          while keypressed do c:=readkey;
          Fenster(4,4,75,22);
        end;
        c:=#0;                                  {normale Tasteneingabe leeren}
      end;                                      {jetzt Pfeiltasten etc}
    if (ord(c)=72) and (Pos>1) then             {ein hoch + ev. scrollen}
    begin
      dec(Pos);
      if (Pos<Scroll) and (Scroll>1) then dec(Scroll);
    end;
    if (ord(c)=80) and (Pos<(Anzahl+AnzahlD)) then
    begin                                       {eins runter + ev. scrollen}
      inc(Pos);
      if (Pos>(Scroll+16)) and (Scroll<(Anzahl+AnzahlD)) then inc(Scroll);
    end else
    if (ord(c)=80) and (Pos=(Anzahl+AnzahlD))   {nur noch scrollen}
      and (Scroll<(Anzahl+AnzahlD-8)) then inc(Scroll);
    if (ord(c)=83) and (pos>AnzahlD) then       {Datei lschen}
    begin
      DeleteFile(FileList[pos-AnzahlD].Name);   {Lschen}
      Erg:=1;                                   {und Aktualisieren}
    end;
  until (Erg<>0);                               {bis Auswahl getroffen}
  choose:=Erg;                                  {Rckmeldung an Hauptprogramm}
end;


procedure WinAut(name : string);                {Automatische Fensterung}

var open    : file;
    min,max : word;                             {kleinste/grsste Farbwerte}
    x,y     : word;
    col     : word;
    buf     : array[1..512] of word;

begin
  assign(open,name);
  reset(open,1);
  seek(open,imainfo.header);                    {Dateikopf berspringen}
  max:=0; min:=0;
  for y:=1 to imainfo.picy do
    begin
      blockread(open,buf,imainfo.picx*2);       {Zeile einlesen}
      for x:=1 to imainfo.picx do
        begin
          col:=buf[x];
          if min>col then min:=col              {Untere / obere Grenze}
            else if max<col then max:=col;      {der vokommenden Farben}
        end;                                    {festlegen}
    end;
  close(open);
  center:=((max-min) div 2) + min;              {Fensterungsmitte}
  width:=max-min;                               {Fensterbreite}
  if center<1 then center:=1;
  if width<1 then width:=1;
  if center>4095 then center:=4095;
  if width>4095 then width:=4095;
end;


procedure LoadIma(name : string);               {Bild in Puffer einlesen}
                                                {und ggf. verkleinern}
var open : file;
    mag  : real;
    x,y  : longint;
    TempPuffer : pointer;
    IOffSet, TOffSet : longint;

begin
  if imainfo.picx<imainfo.picy then             {Grsste Ausdehnung}
    x:=imainfo.picy else x:=imainfo.picx;
  if x<200 then mag:=1                          {Grsser als Grafikmodus ?}
    else mag:=200/real(x);                      {Verkleinerungsfaktor}
  showx:=trunc(mag*imainfo.picx);               {Anzuzeigende Bildgrsse}
  showy:=trunc(mag*imainfo.picy);

  assign(open,name);
  reset(open,1);
  seek(open,imainfo.header);                    {Dateikopf berspringen}

  getmem(TempPuffer,imainfo.picx*imainfo.picy*2); {Platz fr einzulesende Bild reservieren}
  getmem(ImaPuffer,showx*showy*2);                {Platz fr verkleinertes Bild reservieren}
  blockread(open,TempPuffer^,imainfo.picx*imainfo.picy*2);  {Bild komplett einlesen}
  for y:=0 to imainfo.picy-1 do                   {Bild Punkt fr Punkt verkleinern und in ImaPuffer kopieren}
     for x:= 0 to imainfo.picx-1 do
     begin
       IOffSet := (trunc(y*mag)*showx+trunc(x*mag))*2;
       TOffSet := (y*imainfo.picx+x)*2;
       asm                                      {Pixel vom einen in den anderen Puffer kopieren}
         mov eax,ImaPuffer
         add eax,IOffSet
         mov ebx,TempPuffer
         add ebx,TOffSet
         mov cx, word ptr [ebx]
         mov word ptr [eax],cx
       end;
     end;
  freemem(TempPuffer,imainfo.picx*imainfo.picy*2); {TempPuffer freigeben}
  close(open);
end;


procedure ReleaseIma;                           {Dynamische Var. freigeben}

begin
  freemem(imapuffer,showx*showy*2);
end;


procedure ShowIma;                              {Bild aus Puffer anzeigen}

var p    : ^word;
    x,y  : word;
    col  : word;
    t    : longint;

begin
  if ((showx<200) or (showy<200)) then          {Bild kleiner als 200x200 ?}
    for y:=0 to 199 do                          {--> Dann Bildpuffer leeren}
      for x:=0 to 199 do
        bildpuffer[y*320+x]:=0;
  for y:=0 to showy-1 do                        {Pixel aus Puffer holen}
     for x:=0 to showx-1 do
       begin
            t:=(y*showx+x)*2;
          asm
            mov eax,ImaPuffer
            add eax,t
            mov bx,word ptr [eax]
            mov col,bx
          end;
                                                {Pixel fenstern}
         if col<=(center-(width div 2)) then col:=0
           else if col>=(center+(width div 2)) then col:=255
           else
           begin
             dec(col,center-(width div 2));
             col:=round((real(col) / real(width)) * 255);
           end;
           bildpuffer[y*320+x]:=col;
       end;
  waitretrace;
  dosmemput($A000,0,bildpuffer,320*200);        {Bild auf Bildschirm ausgeben}
end;


function InitMouse(X1,Y1,X2,Y2 : integer) : byte;   {Maus initialisieren}

var i33   : pointer;
    error : integer;
    regs  : registers;

begin
  getintvec(MouseIRQ,i33);
  if i33 <> NIL then
  begin
    asm
      mov AX,00h
      int MouseIRQ
      mov error,AX
      sub error,$FFFF
    end;
    if error<>0 then error:=1;                  {Keine Maus}
  end
  else error:=2;
  InitMouse:=error;                             {Kein Treiber}
  with regs do                                  {Aktionsradius}
  begin
    ax:=$07; cx:=X1; dx:=X2; intr(MouseIRQ,regs);
    ax:=$08; cx:=Y1; dx:=Y2; intr(MouseIRQ,regs);
  end;
end;


procedure SetMouseStates(X,Y:integer);assembler;{Maus Postion festlegen}

asm
  mov ax,04h
  mov cx,X
  mov dx,Y
  int MouseIRQ
end;


procedure GetMouseStates(var ButtonPos : MouseState);
                                                {Maus Status abfragen}
var A : MouseState;

begin
  asm
    mov ax,03h
    int MouseIRQ
    mov A.Button,bx;
    mov A.X,cx
    mov A.Y,dx
  end;
  ButtonPos:=A;
end;


procedure BMPSave(num : byte);                  {Bild als Bitmap abspeichern}

var BMPName : String;
    BMP     : text;
    NEMA    : file;
    x,y     : integer;
    li      : longint;
    buf     : array[1..512] of word;
    col     : word;

begin
  BMPName:='';                                  {Abspeichern unter BMPName}
  x:=1;
  while (x<length(FileList[num].Name)) and (copy(FileList[num].Name,x,1)<>'.')
  do begin
       BMPName:=BMPName+copy(FileList[num].Name,x,1);
       inc(x);
     end;
  BMPName:=BMPName+'.bmp';
  assign(BMP,BMPName);                          {BMP Header schreiben}
  rewrite(BMP);
  write(BMP,#$42#$4d);                          {BMP Dateikennung}
  li:=(ImaInfo.Picx*ImaInfo.Picy)+1078;         {BMP Dateigre}
  write(BMP,chr(lo(lo(li))),chr(hi(lo(li))));
  write(BMP,chr(lo(hi(li))),chr(hi(hi(li))));
  write(BMP,#$00#$00#$00#$00);                  {Reserviert}
  write(BMP,#$36#$04#$00#$00);                  {Entfernung bis Bilddaten}
  write(BMP,#$28#$00#$00#$00);                  {Gre BMPInfoHeader}
  write(BMP,chr(lo(ImaInfo.Picx)),              {Breite des Bildes}
            chr(hi(ImaInfo.Picx)),#$00#$00);
  write(BMP,chr(lo(ImaInfo.Picy)),              {Hhe des Bildes}
            chr(hi(ImaInfo.Picy)),#$00#$00);
  write(BMP,#$01#$00);                          {Anzahl Bildebenen}
  write(BMP,#$08#$00);                          {Bits pro Pixel}
  write(BMP,#$00#$00#$00#$00);                  {Keine Komprimierung}

  li:=ImaInfo.Picx*ImaInfo.Picy;                {Gre der Bilddaten}
  write(BMP,chr(lo(lo(li))),chr(hi(lo(li))));   {Bilddateigrsse}
  write(BMP,chr(lo(hi(li))),chr(hi(hi(li))));
  write(BMP,#$61#$0F#$00#$00);                  {Horizontale Auflsung}
  write(BMP,#$61#$0F#$00#$00);                  {Vertikale Auflsung}
  write(BMP,#$00#$00#$00#$00);                  {Anzahl der benutzten Farben}
  write(BMP,#$00#$00#$00#$00);                  {Anzahl wichtiger Farben}
  for x:=0 to 255 do
    write(BMP,chr(x),chr(x),chr(x),#0);         {Farbtabelle}
  assign(NEMA,FileList[num].Name);              {Nema Bild ffnen}
  reset(NEMA,1);
  for y:=(ImaInfo.picy-1) downto 0 do
  begin
    seek(NEMA,ImaInfo.header+ImaInfo.picx*2*y);
    blockread(NEMA,buf,ImaInfo.picx*2);         {Zeile einlesen}
    for x:=1 to ImaInfo.picx do                 {Pixel fenstern / speichern}
    begin
      col:=buf[x];
      if col<=(center-(width div 2)) then col:=0    {Unterhalb des Fensters}
        else if col>=(center+(width div 2)) then col:=255   {Oberhalb}
        else
        begin
          dec(col,center-(width div 2));        {Werte unter Fenster abschneiden}
          col:=round((real(col) / real(width)) * 255);
        end;                                    {Fenster auf 256 Farben aufteilen}
      write(BMP,chr(col));                      {Pixel in BMP schreiben}
    end;
  end;
  close(NEMA);                                  {Nema schlieen}
  close(BMP);                                   {BMP schlieen}
end;


procedure AnzeigenKonvertieren;

begin
  nn:=1;                                        {Suche 1. markierte Datei}
  while ((FileList[nn].Mark=false) and (nn<=Anzahl))
    do inc(nn);
  if (nn>Anzahl) then                           {keine Datei markiert}
  begin
    Textbackground(7);
    Textcolor(1);
    gotoxy(1,2);
    for nn:=2 to 23
       do for mm:=1 to 80 do write(chr(176));
    fenster(15,12,65,14);
    gotoxy(18,13);
    write('Bitte zuerst Bilder mit Leertaste markieren !');
    gotoxy(80,25);
    delay(1500);
  end else
  begin                                         {Markierte Dateien anzeigen}
    graph(true);                                {Grafikmodus}
    InitMouse(1,1,4095,4095);                   {Maus initialisieren und}
                                                {Aktionsradius auf maximale}
                                                {Fensterungswerte setzen}
    getheader(FileList[nn].Name);               {erste Datei :  Dateikopf}
    loadima(FileList[nn].Name);                 {erste Datei :  Bilddaten}
    winaut(FileList[nn].Name);                  {automatisch Fenstern}
    showima;                                    {und anzeigen}
    repeat
      cc:=#1;                                   {Tastatureingabe rcksetzen}
      repeat                                    {Auf (Maus-) Tastendruck}
        GetMouseStates(Mausi);                  {warten}
      until keypressed or (Mausi.button<>0);
      if keypressed then cc:=readkey;           {Tastatureingabe}
      if (cc=#0) and keypressed then            {Pfeiltasten gedrckt}
      begin
        cc:=readkey;
        if (ord(cc)=75) and (nn>1) then         {ein Bild zurck}
        begin
          mm:=nn;
          dec(nn);                              {letzte Markierung suchen}
          while (FileList[nn].Mark=false) and (nn>1) do dec(nn);
          if ((nn=1) and (FileList[nn].Mark=false)) then
            nn:=mm else                         {gehts weiter zurck ?}
            begin
              releaseima;                       {Bildspeicher freigeben}
              getheader(FileList[nn].Name);     {neuen Dateikopf einlesen}
              loadima(FileList[nn].Name);       {neue Bilddaten einlesen}
              showima;                          {und anzeigen}
            end;
        end;
        if (ord(cc)=77) and (nn<Anzahl) then
        begin                                   {ein Bild vor}
          mm:=nn;
          inc(nn);                              {nchste Markierung suchen}
          while ((FileList[nn].Mark=false) and (nn<Anzahl)) do inc(nn);
          if ((nn=Anzahl) and (FileList[nn].Mark=false)) then
            nn:=mm else                         {gehts weiter vor ?}
            begin
              releaseima;                       {Bildspeicher freigeben}
              getheader(FileList[nn].Name);     {neuen Dateikopf einlesen}
              loadima(FileList[nn].Name);       {neue Bilddaten einlesen}
              showima;                          {und anzeigen}
            end;
        end;
        if (ord(cc)=72) then                    {ganz an Anfang}
        begin
          mm:=1;                                {erstes markiertes Bild}
          while (FileList[mm].Mark=false) do inc(mm);
          if (mm<>nn) then                      {neues = aktuelles Bild ?}
          begin
            nn:=mm;
            releaseima;                         {Bildspeicher freigeben}
            getheader(FileList[nn].Name);       {neuen Dateikopf einlesen}
            loadima(FileList[nn].Name);         {neue Bilddaten einlesen}
            showima;                            {und anzeigen}
          end;
        end;
        if (ord(cc)=80) then                    {ganz an Schluss}
        begin
          mm:=Anzahl;                           {letztes markiertes Bild}
          while (FileList[mm].Mark=false) do dec(mm);
          if (mm<>nn) then                      {neues = aktuelles Bild ?}
          begin
            nn:=mm;
            releaseima;                         {Bildspeicher freigeben}
            getheader(FileList[nn].Name);       {neuen Dateikopf einlesen}
            loadima(FileList[nn].Name);         {neue Bilddaten einlesen}
            showima;                            {und anzeigen}
          end;
        end;
      end;
      if upcase(cc)='B' then BMPSave(nn);       {Als BMP speichern}
      if upcase(cc)='A' then                    {Automatisch fenstern}
      begin
        winaut(FileList[nn].Name);              {fentern...}
        showima;                                {...und neu anzeigen}
      end;
      if (Mausi.Button<>0) then                 {Maustaste gedrckt ?}
        begin                                   {--> fenstern}
          SetMouseStates(width,center);         {Fensterungswerte auf Maus}
          while Mausi.Button<>0 do              {setzen}
          begin
            GetMouseStates(Mausi);
            if ((width<>Mausi.X) or (center<>Mausi.Y)) then
              begin                             {Mausposition verndert ?}
                width:=Mausi.X;                 {Dann neue Fensterung}
                center:=Mausi.Y;                {anzeigen}
                ShowIma;
              end;
          end;
        end;
    until (cc=#27) or (upcase(cc)='Q');         {zurck zum Hauptmen}
    releaseima;                                 {Dyn. Speicher freigeben}
    graph(false);                               {Textmodus}
    Fenster(0,0,0,0);                           {Hintergrund}
  end;
end;


begin                                           {*** Hauptprogramm ***}
  nn:=0;                                        {Variable init.}
  GetDir(nn,CurDir);                            {Aktuelles Verzeichnis merken}
  CheckCompleteness('nema2bmp.exe');            {Programm auf Vollstndigkeit}
  CheckCompleteness('nema2bmp.src');            {berprfen}
  CheckCompleteness('nema2bmp.pas');
  nn:=InitMouse(1,1,10,10);                     {Maus probeweise}
  case nn of
    0: ;
    1: SchwererAusnahmefehler('Keine Maus vorhanden ?!');
    2: SchwererAusnahmefehler('Maustreiber nicht installiert ?!');
  else
    SchwererAusnahmefehler
    ('Unbekannter Fehler beim Initialisieren der Maus.');
  end;
  TextMode(co80);                               {Textmodus}
  Fenster(0,0,0,0);                             {Hintergrund}
  Repeat                                        {Hauptmen-Schleife}
    GetFileList;                                {Bilder im Verz. suchen}
    Whattodo:=Choose;                           {Auswahl-Funktion starten}
    if Whattodo=1 then ;                        {Aktualisieren}
    if Whattodo=2 then AnzeigenKonvertieren;    {Anzeigen / Konvertieren}
  until Whattodo=3;                             {Programm beenden}
  textmode(co80);                               {nochmal Textmodus}
  textbackground(0);                            {Standard-Farben}
  textcolor(7);
  ChDir(CurDir);                                {Verzeichnis zurcksetzen}
  clrscr;                                       {...und tsch !}
  writeln('Vielen Dank ...');
  writeln;
  writeln;
end.
